/*******************************************************************************
  Copyright (c), 1998-2017, Ϻ΢ӼŹɷ޹˾

  ļ: i2c.c
  ļ: 

 
  ޶¼:
         1. : LiJie
            : 2017-3-15
            : v1.0
         2. : 
            : 
            : 
*******************************************************************************/

/* Includes ------------------------------------------------------------------*/
#include "ex_var.h"
#include "FM3316_I2C.h"
#include <intrins.h>
#include <string.h>

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
unsigned char SSP_TBIT;// 			8		//36us	ʱ
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/


/*************************************************************************
 ƣInit_I2C
 ˵ʼI2C,Ŀǰ֧ж
 
 unsigned char Ch		0ͨPB6&71ͨPE5&6
 unsigned int BaudRate	ͨŲ   xx_kHz 
 unsigned char Fmclk	ϵͳʱƵ xx_mHz
 
 ز
 *************************************************************************/
void Init_I2C( unsigned char Ch, unsigned int BaudRate, unsigned char Fmclk )
{
	unsigned int Temp16;
	
	if( Ch == 0 )
	{
		PBFCR2 |= B1100_0000;
		PBFCR1 &= (~B1100_0000);
		AFSELB &= (~B1100_0000);
		PBPUEN |= B1100_0000;
	}
	else
	{
		PEFCR2 |= B0110_0000;
		PEFCR1 &= (~B0110_0000);
		AFSELE |= B0110_0000;	
		PEPUEN |= B0110_0000;
	}
	
	SSP_TBIT = Fmclk*4;
	
	Temp16 = (Fmclk*250)/BaudRate - 1;
	
	SSPCON = B0110_0000;
	
	SSPBRGH = (Temp16>>8)&0x00FF;
	SSPBRG  = Temp16&0x00FF; //I2C
	SSPIR 	= B0000_0000;	 //ֹI2Cж
}

/*************************************************************************
 ƣI2c_Send_Bit
 ˵ʼλֹͣλACK
 
 
 ز0ɹ1ʧ
 *************************************************************************/
unsigned char I2c_Send_Bit( unsigned char x_byte ) 
{
	unsigned char i;

	SSPCON = x_byte;

	for( i=0; i<2*SSP_TBIT; i++ )
	{
		if( (SSPIR&0x01) == 0x01 ) break;
	}

	if( i < 2*SSP_TBIT )
	{
		SSPIR &= ~B0000_0001; //clr int flag

		i = SSPSTAT; //clr flag through reading SSPSTA.
		
		return 0; //ok
	}
	else
	{
		return 1; //failure.
	}
}

/*************************************************************************
 ƣI2c_Send_Byte
 ˵һֽ
 
 
 ز0ɹ1ʧ
 *************************************************************************/
unsigned char I2c_Send_Byte( unsigned char x_byte ) 
{
	unsigned int i;

	SSPBUF = x_byte;

	for( i=0; i<18*SSP_TBIT; i++ )
	{
		if( (SSPIR&0x01) == 0x01 ) break; //жϱ־λʱѭ
	}
	
	if( i < 18*SSP_TBIT )
	{
		SSPIR &= (~0x01); //clr int flag

		if( (SSPSTAT&0x02) == 0x02 ) //ӻӦ
		{
			return 2; //ʧ
		}
		else
		{
			return 0; //ɹ
		}
	}
	else
	{
		return 1; //failure.
	}
}

/*************************************************************************
 ƣI2c_Receive_Byte
 ˵ȡһֽ
 ַ
 ȡ
 ز0ɹ1ʧ
 *************************************************************************/
unsigned char I2c_Receive_Byte( unsigned char *x_byte ) 
{
	unsigned int i;

	SSPCON = B1000_1000;	//i2c en, rcen

	for( i=0; i<18*SSP_TBIT; i++ )
	{
		if( (SSPIR&0x01) == 0x01 ) break; //жϱ־λ, ѭ
	}

	if( i < 18*SSP_TBIT )
	{
		*x_byte = SSPBUF;

		SSPIR &= ~B0000_0001; //clr int flag

		return 0;
	}
	else
	{
		return 1; //failure.
	}
}


/*************************************************************************
 ƣSendaddr
 ˵i2cͨ֡ͷ
 
unsigned char DeviceAddr,  ַ
unsigned int OpAddr,       ַ
unsigned char OpAddrMode,  ַ 01ֽڣ2ֽ
unsigned char Opt          ģʽ 0д 1 
 
 ز0ɹʧ
 *************************************************************************/
unsigned char Sendaddr( unsigned char DeviceAddr, unsigned int OpAddr, unsigned char OpAddrMode, unsigned char Opt ) 
{
	unsigned char result;
	union B16_B08 Addr;

	Addr.B16 = OpAddr;

	//-------------- reset i2c -------------
	SSPCON = B0110_0000;
	for(result=0x00; result<0x03; result++ );
	
	//-------------- start bit -------------
	result = I2c_Send_Bit( B1000_0001 );
	if( result != 0 ) return 1; //failure.

	//-------------- device addr -------------
	result = I2c_Send_Byte( DeviceAddr ); //ַ
	if( result != 0 ) return 2; //failure.

	//--------------- data addr --------------
	if( OpAddrMode != 0 )
	{
		result = I2c_Send_Byte( Addr.B08[0] ); //ݵַλ
		if( result != 0 ) return 3; //failure.
	}

	result = I2c_Send_Byte( Addr.B08[1] ); //ݵַλ
	if( result != 0 ) return 3; //failure.

	if( Opt == 1 ) //
	{
		result = I2c_Send_Bit( B1000_0010 ); //ʼλ
		if( result != 0 ) return 5; //failure.
		
		result = I2c_Send_Byte( DeviceAddr|1 ); //ַ,ȡ
		if( result != 0 ) return 5; //failure.
	}
		
	return 0; //ok
}
  
/*************************************************************************
 ƣWait_for_end
 ˵ȴi2c
 unsigned char DeviceAddr ַ
 
 ز0ɹ1ʧ
 *************************************************************************/
unsigned char Wait_for_end( unsigned char DeviceAddr )
{
	unsigned char result;
	unsigned int i;
	
	for( i=0; i<100; i++ ) //Ҫ5msڲд, ѭһʱ: 42Delay()
	{
		I2c_Send_Bit( B1000_0001 );	//ʼλ

		result = I2c_Send_Byte( DeviceAddr ); //ַ

		I2c_Send_Bit( B1000_0100 ); //ֹͣλ

		if( result == 0 ) return 0; //õַɹ, дڽ
	}

	return 1; //õַʧ
}

/*************************************************************************
 ƣI2C_Write_Bottom
 ˵i2cײд
 
unsigned char DeviceAddr,  ַ
unsigned int OpAddr,       ַ
unsigned char OpAddrMode,  ַ 01ֽڣ2ֽ
unsigned char *Buf,        дݻַ
unsigned char h            д볤
 
 ز0ɹ1ʧ
 *************************************************************************/
unsigned char I2C_Write_Bottom(unsigned char DeviceAddr, unsigned int OpAddr, unsigned char OpAddrMode, unsigned char *Buf, unsigned char h)
{
	unsigned char k, n, status;
	
	for( k=0; k<3; k++ )//ÿд3 
	{                                   	
		status = 0;
		if( Sendaddr( DeviceAddr, OpAddr, OpAddrMode, 0 ) ) status = 1; //дʧ
		else 
		{
			for( n=0; n<h; n++ )
			{
				//һֽ
				if( I2c_Send_Byte( Buf[n] ) ) {status = 1; break;} //дʧ
			}
		}
		//ֹͣλ
		if( I2c_Send_Bit( B1000_0100 ) ) status = 1;
		
		if( status == 0 ) {Wait_for_end(DeviceAddr); break;}//дȷ
	}
	
	return( status );
}

/*************************************************************************
 ƣI2C_Read_Bottom
 ˵i2cײ
 
unsigned char DeviceAddr,  ַ
unsigned int OpAddr,       ַ
unsigned char OpAddrMode,  ַ 01ֽڣ2ֽ
unsigned char *Buf,        ݻַ
unsigned char h            ȡ
 
 ز0ɹ1ʧ
 *************************************************************************/
unsigned char I2C_Read_Bottom(unsigned char DeviceAddr, unsigned int OpAddr, unsigned char OpAddrMode, unsigned char *Buf, unsigned char h)
{
	unsigned char k, n, status;
	
	for( k=0; k<3; k++ )//ÿ3
	{
		status = 0;
		if( Sendaddr( DeviceAddr, OpAddr, OpAddrMode, 1 ) ) status = 1; //дʧ
		else 
		{
			for( n=0; n<h; n++ )
			{
				//һֽ
				if( I2c_Receive_Byte( Buf+n ) ) {status = 1; break;} 
        		
				if( n < (h-1) )	SSPSTAT = B0000_0000;
				else		SSPSTAT = B0000_0001;
				
				{
					// ACK
					if( I2c_Send_Bit( B1001_0000) )  {SSPSTAT = B0000_0000;status = 1; break;}	//ʧ
					SSPSTAT = B0000_0000;
				}
			}
		}
		//ֹͣλ
		if( I2c_Send_Bit( B1000_0100 ) ) status = 1;	//ʧ
		
		if( status == 0 ) break;//ȷ
	}
	
	return( status );
}
