/*******************************************************************************
  Copyright (c), 1998-2017, Ϻ΢ӼŹɷ޹˾

  ļ: FM3316_RTC.c
  ļ: FM3316_RTC ģ

 
  ޶¼:
         1. : ˲
            : 2017-03-10
            : V1.0
         2. : 
            : 
            : 
*******************************************************************************/

/* Includes ------------------------------------------------------------------*/
#include "fm3316reg.h"
#include "BinToHex.h"
#include <intrins.h>
#include <string.h>
#include <stdio.h>
#include "FM3316_RTC.h"

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
SYS_CLOCK_FRM	Sclock;	//ʱ
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/
extern void I2c_Wait_5ms(void);
/*************************************************************************
 ƣRTC_Interrupt_Enable
 ˵RTCжʹ
 rtc_sel жʱѡ
 
 ز
 *************************************************************************/
void RTC_Interrupt_Enable(unsigned short rtc_sel)
{
	RTCIE2 |= rtc_sel>>8;
	RTCIE1 |= rtc_sel;
}

/*************************************************************************
 ƣRTC_Interrupt_Disable
 ˵RTCжϹر
 rtc_sel жʱѡ
 
 ز
 *************************************************************************/
void RTC_Interrupt_Disable(unsigned int rtc_sel)
{
	RTCIE2 &= ~rtc_sel>>8;
	RTCIE1 &= ~rtc_sel;
}

/*************************************************************************
 ƣRTC_Interrupt_Flag_Clear
 ˵RTCжϱ־
 rtc_sel жѡ
 
 ز
 *************************************************************************/
void RTC_Interrupt_Flag_Clear(unsigned int rtc_sel)
{
	RTCIF2 &= ~rtc_sel>>8;
	RTCIF1 &= ~rtc_sel;
}

/*************************************************************************
 ƣRTC_Write_Enable
 ˵RTCдֵʱʹ
 
 
 ز
 *************************************************************************/
void RTC_Write_Enable(void)
{
	RTCWE = 0xAC;
}

/*************************************************************************
 ƣRTC_Write_Disable
 ˵RTCдֵʱر
 
 
 ز
 *************************************************************************/
void RTC_Write_Disable(void)
{
	RTCWE = 0x00;
}

/*************************************************************************
 ƣRTC_Byte_Is_BCD
 ˵ֽǷBCD
 
 
 ز0 BCD 1 BCD
 *************************************************************************/
unsigned char RTC_Byte_Is_BCD( unsigned char Value )
{
	if( ((Value&0xF0)<=0x90) && ((Value&0x0F)<=0x09) )
	{
		return 0;
	}
	else
	{
		return 1;
	}
}

/*************************************************************************
 ƣRTC_Judge_Clock
 ˵жʱǷϷ  ʱ    
 Start ʼ  Ck ʱ buf len 
 
 ز0 ȷ 1 
 *************************************************************************/
unsigned char RTC_Judge_Clock( unsigned char Start, unsigned char *Ck, unsigned char Len )
{
	unsigned char  i,j;
	unsigned char code Max[]={ 0x59,0x59,0x23,0x6,0x31,0x12,0x99 }, code Min[]={ 0x00,0x00,0x00,0x00,0x01,0x01,0x00 };
	for( i=0; i<(Len&0x07); i++ )
	{
		j=i+Start;
		if((j>=3)&&(Len&0x80))	j++;
		if( (Ck[i] > Max[j]) || (Ck[i] < Min[j]) ) return 1;//ϷԼ
		if( RTC_Byte_Is_BCD(Ck[i]) ) return 1;	//BCD		   
	}
	return 0;//ȷ
}

/*************************************************************************
 ƣRTC_Read_Rtc
 ˵ȡʱ
 RTC_Buf  ʱָ
 RTC_Buf
 ز0 ȷ 1 
 *************************************************************************/
unsigned char RTC_Read_Rtc( unsigned char *RTC_Buf )
{
	unsigned char i, n, Result;
	unsigned char BufA[7], BufB[7];

	for( n=0; n<3; n++ )
	{
		BufA[0] = BCDSEC;
		BufA[1] = BCDMIN;
		BufA[2] = BCDHOUR;
		BufA[3] = BCDWEEK;
		BufA[4] = BCDDATE;
		BufA[5] = BCDMONTH;
		BufA[6] = BCDYEAR;

		BufB[0] = BCDSEC;
		BufB[1] = BCDMIN;
		BufB[2] = BCDHOUR;
		BufB[3] = BCDWEEK;
		BufB[4] = BCDDATE;
		BufB[5] = BCDMONTH;
		BufB[6] = BCDYEAR;

		for( i=0; i<7; i++ ) //ȶʱǷһ
		{
			if( BufA[i] != BufB[i] ) break;
		}

		if( i == 7 ) //һ, ʾȡɹ
		{
			Result = RTC_Judge_Clock( 0, BufA, 7 ); //жʱǷϷ
			if( Result == 0 ) //ʱӺϷ
			{
				for( i=0; i<7; i++ )
				{
					RTC_Buf[i] = BufA[i];
				}
			
				return 0;
			}
		}
	}
	
	for( i=0; i<7; i++ )
	{
		RTC_Buf[i] = BufA[i];//ʹҲҪʱ
	}
	return 1;
}

/*************************************************************************
 ƣRTC_Set_Rtc
 ˵ʱ
 Start ʼ  Ck ʱ buf len 
 
 ز0 ȷ 1 
 *************************************************************************/
unsigned char RTC_Set_Rtc( unsigned char Start, unsigned char *Ck, unsigned char Len )
{
	unsigned char i, n, Result;
	unsigned char BufB[7];
	
	Result = RTC_Judge_Clock( Start, Ck, Len );
	if( Result == 1 )
	{
		return 1;
	}
	for( n=0; n<3; n++ )
	{
		RTCWE = 0xAC;     //ʹRTCд
		BCDSEC 	= Ck[0];
		BCDMIN 	= Ck[1];
		BCDHOUR	= Ck[2];
		BCDWEEK	= Ck[3];
		BCDDATE	= Ck[4];
		BCDMONTH	= Ck[5];
		BCDYEAR	= Ck[6];		
		RTCWE = 0x00;     //ֹRTCд
		Result = RTC_Read_Rtc( BufB );
		if( Result == 0 ) //ȡɹ
		{
			for( i=0; i<7; i++ )
			{
				if( Ck[i] != BufB[i] ) break;
			}
			if( i == 7 ) //ǰֵֵ, óɹ
			{
				return 0; //óɹ
			}
		}
	}
	return 1; //ʧ
}

/*************************************************************************
 ƣRTC_Syn_Clock
 ˵ʱӱ
 
 
 ز
 *************************************************************************/
void RTC_Syn_Clock( void )	//ͬͱʱ
{
	Sclock.Clockbackup[0] = Sclock.Clockmain[6];//
	Sclock.Clockbackup[1] = Sclock.Clockmain[5];//
	Sclock.Clockbackup[2] = Sclock.Clockmain[4];//
	Sclock.Clockbackup[3] = Sclock.Clockmain[3];//
	Sclock.Clockbackup[4] = Sclock.Clockmain[2];//ʱ
	Sclock.Clockbackup[5] = Sclock.Clockmain[1];//
	Sclock.Clockbackup[6] = Sclock.Clockmain[0];//
}

/*************************************************************************
 ƣRTC_Read_Sysclock
 ˵ʱӴñʱ Ķʱ
 
 
 ز
 *************************************************************************/
void RTC_Read_Sysclock( void )
{
unsigned char Result,Buf[10];
	Result = RTC_Read_Rtc( Sclock.Clockmain );//ʱ
	if( Result == 1 )
	{
		I2c_Wait_5ms(); 	//ʱ
		Result = RTC_Read_Rtc( Sclock.Clockmain );//ٶʱ
		if( Result == 1 )
		{
			if( Sclock.Status == 0 ) 
			{
				Sclock.Status = 1;//ʱӴ־
				Buf[0] = Sclock.Clockbackup[6];
				Buf[1] = Sclock.Clockbackup[5];
				Buf[2] = Sclock.Clockbackup[4];
				Buf[3] = Sclock.Clockbackup[3];
				Buf[4] = Sclock.Clockbackup[2];
				Buf[5] = Sclock.Clockbackup[1];
				Buf[6] = Sclock.Clockbackup[0];
				RTC_Set_Rtc( 0, Buf, 7 );//ramȷʱдrtc
				return;
			}
		}
	}
	if( Result == 0 ) Sclock.Status = 0;//ʱӴ־
	RTC_Syn_Clock();//ͬͱʱ	 
}

/*************************************************************************
 ƣRTC_Fout_Select
 ˵RTC Fout ѡ FOUT0 ȷ
 select  
           0:ߵƽȷ뷽 1: ߵƽ80ms ʱ 2ߵƽλź 3: ߵƽֽλź 
					 4:ߵƽСʱλź 5:ߵƽսλź 6ߵƽƥź 7 128뷽ź
           8:͵ƽ80ms ʱ 9͵ƽλź 10: ͵ƽֽλź  11:͵ƽСʱλź 
					12:͵ƽսλź 13͵ƽƥź  14:͵ƽȷ뷽 15: RTC ڲʱ귽 
 
 ز
 *************************************************************************/
void RTC_Fout_Select(unsigned int fsel)
{
	FSEL = fsel;
}

/*************************************************************************
 ƣRTC_Set_Alarm
 ˵ʱ 
 Ck: ʱ buf   ʱ 3ֽBCD 
 
 ز0 ȷ 1 
 *************************************************************************/
unsigned char RTC_Set_Alarm( unsigned char *Ck )
{
unsigned char Result;	
	Result = RTC_Judge_Clock( 0, Ck, 3 );
	if( Result == 1 )
	{
		return 1;
	}
	ALARMSEC 	= Ck[0];
	ALARMMIN 	= Ck[1];
	ALARMHOUR	= Ck[2];
	return 0;
}

/*************************************************************************
 ƣRTC_Adjust_Ltbc
 ˵RTC У׼ֵд
 adsign  0  1 ١adjust ֵ visual У 0 ʹܣ1 ֹ
 
 ز
 *************************************************************************/
void RTC_Adjust_Ltbc(unsigned char adsign,unsigned int adjust,unsigned char visual)
{
	ADSIGN = adsign;  
	ADJUST = adjust;
	ADJUST1 = (adjust>>8)&0x07;	
	PRLSEN = visual;
}

/************************* (c),Ϻ΢ӼŹɷ޹˾ ***END OF FILE***/
