// Note: logs are saved into "LogFile.log"

//-------------------------------------------
// FUNCTION FOR FLASH PROGRAMMING A SINGLE BYTE
//
//    This function is called using LOAD button
//-------------------------------------------

//fm375 flash op register define
//Flash Control Unit
#define ERCSR							0x00C000E0			//FlashƼĴ
#define PRCSR							0x00C000E1			//Flash̿ƼĴ
#define FLSKEY        		0x00C000E3   		//Flash key
#define FLSIE							0x00C000E4			//FlashжʹܼĴ
#define EPFLAG						0x00C000E6			//FLashд־Ĵ

//Clock Control Unit

#define HSDIVSEL					0x00C00040
#define MCLKSEL				   	0x00C00041
#define LCDCLKSEL				  0x00C00042
#define CKSRC_CTRL				0x00C00043
#define RCHFADJ           0x00C00044
#define XTLF_IPWRB				0x00C00045
#define RCLP_TRIM				  0x00C00046
#define PERICLK_CTRL0		  0x00C00047	//ʱſؼĴ
#define	PERICLK_CTRL1			0x00C00048
#define PERICLK_CTRL2     0x00C00049


#define  	NVRAM_ORG			0x00B00E00		//nvram׵ַ


void FlashByteProg (unsigned long int inCodeAddress, unsigned char *inData) {
    unsigned char theBufferStatus;
    unsigned char theData;
    char theLog[256];
    unsigned long int code_high_address;
    unsigned char temp_byte;
    
    _LOG("------------------ FlashByteProg -----------------\n");
	  sprintf(theLog, "Code Address 0x%X\n", inCodeAddress);
    _LOG(theLog);
    sprintf(theLog, "first byte is  0x%X\n",  *inData);
    _LOG(theLog);
    
		
} /* End of FlashByteProg */


//-------------------------------------------
// FUNCTION FOR FLASH PROGRAMMING A SECTOR
//    OR SEVERAL CONSECUTIVE DATA
//
//    This function is called using LOAD button
//-------------------------------------------
void FlashSectorProg (unsigned long int inCodeAddress, unsigned char *inData, unsigned int inCount) {
    unsigned char *theBuffer;
    unsigned char theBufferStatus;
    unsigned long int theCodeAddress;
    unsigned char theData, theWordCount;
    unsigned char isDataToWrite;
    char theLog[256];
    unsigned long int code_high_address;
    unsigned char temp_byte;
    int i;
    
    _LOG("------------------ FlashSectorProg -----------------\n");
//    sprintf(theLog, "Code Address 0x%X, Count 0x%X\n", inCodeAddress, inCount);
//    _LOG(theLog);
  
      if(inCodeAddress == 0xFF0000)
    {
    	 //clear EREQ
    	temp_byte = (unsigned char)0x00;
    	_WNBYTES_CODE(ERCSR,&temp_byte,1);
    	
    }
    //indata move to nvram 
		_WNBYTES_CODE(NVRAM_ORG,inData,inCount);
    
	  //set PREQ
    temp_byte = (unsigned char)0x01;
    _WNBYTES_CODE(PRCSR,&temp_byte,1);   
   
    temp_byte = (unsigned char)0x55;
    _WNBYTES_CODE(inCodeAddress,&temp_byte,1);
    
    _SLEEP(5); 

		_LOG("---------------------------WRITE COMPLETE---------------------------------------\n");
} /* End of FlashSectorProg */


//-------------------------------------------
// FUNCTION FOR FLASH ERASE
//
//    This function is called using ERASE or LOAD buttons
//-------------------------------------------
void FlashErase (void) {
    
    unsigned char theBufferStatus;
    unsigned long int theCodeAddress;
    unsigned char theData;
    unsigned char temp_byte;
    char theLog[256];
    
    _LOG("------------------ FlashErase -----------------\n");
    
    //SET CLK    
    temp_byte = (unsigned char)0x40;
    _WNBYTES_CODE(RCHFADJ,&temp_byte,1);
    
    temp_byte = (unsigned char)0x02;
    _WNBYTES_CODE(CKSRC_CTRL,&temp_byte,1);
   
    temp_byte = (unsigned char)0x00;
    _WNBYTES_CODE(HSDIVSEL,&temp_byte,1);
    _WNBYTES_CODE(MCLKSEL,&temp_byte,1);

    temp_byte = (unsigned char)0x02;
    _WNBYTES_CODE(LCDCLKSEL,&temp_byte,1);
    
    temp_byte = (unsigned char)0xFF;
    _WNBYTES_CODE(PERICLK_CTRL0,&temp_byte,1);
    _WNBYTES_CODE(PERICLK_CTRL1,&temp_byte,1);
    _WNBYTES_CODE(PERICLK_CTRL2,&temp_byte,1);           
        
    //clear PREQ
    temp_byte = (unsigned char)0x00;
    _WNBYTES_CODE(PRCSR,&temp_byte,1);
    
    //set EREQ
    temp_byte = (unsigned char)0x81;
    _WNBYTES_CODE(ERCSR,&temp_byte,1);
    
    temp_byte = (unsigned char)0xC9;
    _WNBYTES_CODE(0xFF0000,&temp_byte,1);
     
    _SLEEP(20);  
    
		//clear flag
		temp_byte = (unsigned char)0x00;
		_WNBYTES_CODE(EPFLAG , &temp_byte, 1);
		

} /* End of FlashErase */


//-------------------------------------------
// FUNCTION FOR FLASH SECTOR ERASE
//
//    This function is called by the BIRD Debug Software
//    to erase the sector corresponding to the given
//    address
//-------------------------------------------
void FlashSectorErase (unsigned long int inCodeAddress) {
		
		unsigned long int code_high_address;
    unsigned char temp_byte;
    char theLog[256];
 
    _LOG("------------------ FlashSectorErase -----------------\n");
    sprintf(theLog, ": the ex addr is 0x%X\n", inCodeAddress);
    _LOG(theLog);
    
    //SET CLK
    if(inCodeAddress == 0xFF0000)
    {
    _LOG("------------------ set clk -----------------\n");
    
    temp_byte = (unsigned char)0x02;
    _WNBYTES_CODE(CKSRC_CTRL,&temp_byte,1);
   
    temp_byte = (unsigned char)0x00;
    _WNBYTES_CODE(HSDIVSEL,&temp_byte,1);
    _WNBYTES_CODE(MCLKSEL,&temp_byte,1);
    
    temp_byte = (unsigned char)0xFF;
    _WNBYTES_CODE(PERICLK_CTRL0,&temp_byte,1);

    //clear PREQ
    temp_byte = (unsigned char)0x00;
    _WNBYTES_CODE(PRCSR,&temp_byte,1);        
   }  
    
    //set EREQ
    temp_byte = (unsigned char)0x01;
    _WNBYTES_CODE(ERCSR,&temp_byte,1);
    
    temp_byte = (unsigned char)0xC9;
    _WNBYTES_CODE(inCodeAddress,&temp_byte,1);
     
    _SLEEP(5);  
		
	} /* End of FlashSectorErase */


//-------------------------------------------
// FUNCTION FOR FLASH READ
//
//    This function is called to configure
//    the flash in read mode
//-------------------------------------------
void FlashSetupRead (void) {
	unsigned char temp_byte;
	char theLog[256];
	
    _LOG("------------------ FlashSetupRead -----------------\n");
    
} /* End of FlashSetupRead */


